Subject: Re: Problem with VLANs and via-velocity driver

From: Patrick McHardy <[email-masked]>
Date: Wed, 10 Feb 2010 17:46:52 +0100

Tiago Pierezan Camargo wrote:
>> Kevin Shanahan <kmshanah <at> disenchant.net> writes:
> 
> Hi
> Sorry for resurrecting an old thread, but I'm having the same problem here.
> 
>> On Fri, Nov 13, 2009 at 07:40:39AM +0100, Patrick McHardy wrote:
>>> Kevin Shanahan wrote:
>>>> Hi,
>>>>
>>>> I've had some problems with getting a fairly simple (I thought) VLAN
>>>> configuration working with the on board Via NICs on my Via M700
>>>> board. Looks like as soon as a tagged VLAN interface is added, the
>>>> underlying "raw" (untagged) interface stops responding.
> 
> My setup is a bit different: I want to sniff all network activity, including
> possible tagged traffic. No tagged interfaces are created.
> 
>>>> A bit of searching found a few references to similar problems going
>>>> back a few years (2005, 2007). Sounded like there were some driver
>>>> issues, but it wasn't clear from the messages I found whether they
>>>> were believed to be fixed or not. I tried the same test using a
>>>> differnt NIC with the tg3 driver and there were no problems, so it
>>>> looks to me like it's still a via-velocity issue. Unfortunately I
>>>> don't have room to add NICs to this machine and need to use the on
>>>> board Via hardware.
>>> There's some special-casing for VID 0 in velocity_init_cam_filter().
>>> Does "ip link add link eth0 type vlan id 0" make any difference?
>> Thanks Patrick, this command got the untagged interface working again
>> (eth1 in my case). I can use this as a work around.
> 
> Unfortunately, Patrick's workaround doesn't work for me. To see any tagged
> packet I need to create a vlan that matches the packet vlan (same id).
> 
> Régis' promiscous mode patch (http://lists.openwall.net/netdev/2008/10/08/106)
> does not work either. I tried to completely disable hw vlan filtering without
> success. It seems my board uses a different register/offset to disable filtering.
> 
> ...
> 
> Any suggestions?

This should be fixed in the driver as discussed previously.